require "class"

Graphics = class()

function Graphics:__init()
	
	self.screenHeight = love.graphics.getHeight()
	self.screenWidth = love.graphics.getWidth()
	
	self.camera = {
		x = 0,
		y = 0
	}
	
	self.drawstack = {}
	
end

function Graphics:update(dt)

	for i, object in pairs(self.drawstack) do
		object:update(dt)
	end

end

function Graphics:draw()

	table.sort(self.drawstack, sortObjects)
	for i, object in pairs(self.drawstack) do
		object:draw()
		if object.physics ~= nil then
			object.physics:draw("line")
		end
	end

end

function sortObjects(a, b)
	return (a.y + a.yOffset) < (b.y + b.yOffset)
end