require "player"
require "network"
require "graphics"
require "map"

Collider = require "hardoncollider"

function love.load()

	math.randomseed(os.time()) 
	
	physics = Collider()

	graphics = Graphics()
	player = Player()
	map = Map('resources/maps/1')
	network = Network()
	
	love.graphics.setBackgroundColor(25, 0, 200)
	
	table.insert(graphics.drawstack, player)
	
	physics:setCallbacks(on_collide, nil)
	
end

function love.update(dt)

	-- player:update(dt  -- taken care of by graphics
	physics:update(dt)
	graphics:update(dt)
	network:update(dt)
	
	graphics.camera.x = (player.x * scale) - (120 * scale)
	graphics.camera.y = (player.y * scale) - (72 * scale)
	
end

function love.draw()

	love.graphics.push()
	
		love.graphics.translate(-graphics.camera.x, -graphics.camera.y)
		love.graphics.scale(scale, scale)
		
		-- network:draw()
		-- player:draw()
		map:draw()
		graphics:draw()
				
	love.graphics.pop()
	
end

function love.keyreleased(key)

	if key == "up" or key == "down" or key == "left" or key == "right" then
		player.moving = false
	end

end

function on_collide(dt, shape_one, shape_two, dx, dy)
	-- print("collide")
	
	local playerCollide = false
	
	if shape_one == player.physics then
		playerCollide = true
	elseif shape_two == player.physics then
		playerCollide = true
	end
	
	if playerCollide and player.moving then
		player.physics:move(0, dy)
		player.physics:move(dx, 0)
		local x, y = player.physics:center()
		player.x = x - (player.width / 2)
		player.y = y - player.height + (player.width / 2)
		--love.graphics.setBackgroundColor(200, 0, 25)
	else
		--love.graphics.setBackgroundColor(25, 0, 200)
	end
	
end

function strSplit(s, delimiter)
    result = {};
    for match in (s..delimiter):gmatch("(.-)"..delimiter) do
        table.insert(result, match);
    end
    return result;
end

