require "class"

Map = class()

function Map:__init(location)

	self.map = require(location)
	
	self.width = self.map.width
	self.height = self.map.height
	
	self.boundries = {}
	
	for i, layer in pairs(self.map.layers) do
		if layer.type == "imagelayer" then
			self.imagePath = "resources/maps/" .. layer.image
			self.sprite = love.graphics.newImage(self.imagePath)
			self.sprite:setFilter("nearest", "nearest")
		elseif layer.type == "objectgroup" then
			for j, object in pairs(layer.objects) do
				if object.shape == "polyline" then
					local line = {}
					local linePoints = {}
					
					for k, segment in pairs(object.polyline) do
						table.insert(linePoints, object.x + segment.x)
						table.insert(linePoints, object.y + segment.y)
					end
				
					--line.shape = love.physics.newChainShape(false, unpack(linePoints))
					--line.physics = physics:addPolygon(unpack(linePoints))
					line.physics = physics:addPolygon(unpack(linePoints))
					physics:addToGroup("boundries", line.physics)
					
					table.insert(self.boundries, line)
				elseif object.type == "spawn" then
					if object.properties.spawn == "player" then
						player.x = object.x
						player.y = object.y
					end
				--elseif object.type == "gameObject" then
					-- table.insert(graphics.drawstack, Object(object.properties.type, object.x, object.y, object.properties.weight, object.properties.static))
				end
			end
		end
	end

end

function Map:draw()

	-- love.graphics.draw(self.sprite, 0, 0)
	for i, boundary in pairs(self.boundries) do
		boundary.physics:draw("fill")
	end

end