require "class"
require "networkPlayer"
local socket = require "socket"

Network = class()

function Network:__init()

	self.address = "localhost"
	self.port = 420
	self.udp = socket.udp()
	self.networkID = tostring(math.random(99999))
	
	self.networkPlayers = {}
	
	self.udp:settimeout(0)
	self.udp:setpeername(self.address, self.port)
	
	self.updateFrequency = 1 / 20
	self.updateTimer = 0
	
	local packet = string.format("%i,%s,%f,%f,%s", 1, self.networkID, player.x, player.y, player.direction)
	self.udp:send(packet)

end

function Network:update(dt)

	-- taken care of by graphics
	-- for id, networkPlayer in pairs(self.networkPlayers) do
		-- networkPlayer:update(dt)
	-- end

	self.updateTimer = self.updateTimer + dt
	if self.updateTimer > self.updateFrequency then
		self.updateTimer = 0
		local packet = string.format("%i,%s,%f,%f,%s", 0, self.networkID, player.x, player.y, player.direction)
		self.udp:send(packet)
	end
	
	data, msg = self.udp:receive()
	if data then
		data = strSplit(data, ",")
		if data[1] == "0" then
			-- position update
			if data[2] ~= self.networkID and self.networkPlayers[data[2]] ~= nil then
				self.networkPlayers[data[2]]:updateState(tonumber(data[3]), tonumber(data[4]), data[5])
			end
		elseif data[1] == "1" then
			-- player join
			if data[2] ~= self.networkID and self.networkPlayers[data[2]] == nil then
				print("player ", data[2], " join")
				self.networkPlayers[data[2]] = NetworkPlayer(tonumber(data[3]), tonumber(data[4]), data[5])
				table.insert(graphics.drawstack, self.networkPlayers[data[2]])
			end
		end
	end
	
end

function Network:draw()

	for id, networkPlayer in pairs(self.networkPlayers) do
		networkPlayer:draw()
	end

end

-- packet defns
-- {id},{type},...
-- send from client (top), reply from server (bottom)

-- 0 (movement update)
	-- 0,{id},{player x},{player y},{direction}... (direction, etc)

-- 1 (player join)
	-- 1,{id},{player x},{player y},{direction}...
	

	
