import socket
import time

clients = {}

class Server:
	
	def __init__(self):
		self.port = 420
		self.sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
		self.sock.bind(("", self.port))
		
	def run(self):
		
		while True:
			
			try:
				data, addr = self.sock.recvfrom(2048)
				data = data.split(",")
				
			except:
				pass
				# print "data recv error"
				
			if data[0] == "0":
				#print "position update from " + data[1] + " at " + data[2] + ", " + data[3]
				if data[1] in clients:
					clients[data[1]].update(float(data[2]), float(data[3]), data[4])
					for client in clients:
						if client != data[1]:
							packet = "0," + clients[data[1]].id + "," + str(clients[data[1]].x) + "," + str(clients[data[1]].y) + "," + clients[data[1]].direction
							self.sock.sendto(packet, (clients[client].addr[0], clients[client].addr[1]))
			elif data[0] == "1":
				if not data[1] in clients.keys():
					print data[1] + " joined the server"
					clients[data[1]] = Client(data[1], float(data[2]), float(data[3]), data[4], addr)
					for client in clients:
						if client != data[1]:
							#tell other client about new one
							packet = "1," + clients[data[1]].id + "," + str(clients[data[1]].x) + "," + str(clients[data[1]].y) + "," + clients[data[1]].direction
							self.sock.sendto(packet, (clients[client].addr[0], clients[client].addr[1])) 
							
							#tell new one about other client
							packet = "1," + clients[client].id + "," + str(clients[client].x) + "," + str(clients[client].y) + "," + clients[client].direction
							self.sock.sendto(packet, (clients[data[1]].addr[0], clients[data[1]].addr[1]))
					
class Client:
	
	def __init__(self, id, x, y, direction, addr):
		self.id = id
		self.x = x
		self.y = y
		self.direction = direction
		self.addr = addr
		
	def update(self, x, y, direction):
		self.x = x
		self.y = y
		self.direction = direction
		
server = Server()
server.run()